Index: soft/giet_vm/boot/boot_init.c
===================================================================
--- soft/giet_vm/boot/boot_init.c	(revision 236)
+++ soft/giet_vm/boot/boot_init.c	(revision 238)
@@ -1262,18 +1198,39 @@
 } // end boot_vobjs_init()
 
-
-void mwmr_hw_init(void * coproc, enum mwmrPortDirection way,
-        unsigned int no, const mwmr_channel_t * pmwmr) {
-    volatile unsigned int *cbase = (unsigned int *) coproc;
-
-    cbase[MWMR_CONFIG_FIFO_WAY] = way;
-    cbase[MWMR_CONFIG_FIFO_NO] = no;
-    cbase[MWMR_CONFIG_STATUS_ADDR] = (unsigned int) pmwmr;
-    cbase[MWMR_CONFIG_WIDTH] = pmwmr->width;
-    cbase[MWMR_CONFIG_DEPTH] = pmwmr->depth;
-    cbase[MWMR_CONFIG_BUFFER_ADDR] = (unsigned int) &pmwmr->data;
-    cbase[MWMR_CONFIG_RUNNING] = 1;
-}
-
+////////////////////////////////////////////////////////////////////////////////
+// This function initializes one MWMR controller channel.
+// - coproc_pbase  : physical base address of the Coproc configuration segment
+// - channel_pbase : physical base address of the MWMR channel segment
+// Warning : the channel physical base address should be on 32 bits, as the
+// MWMR controller configuration registers are 32 bits.
+// TODO : Introduce a MWMR_CONFIG_PADDR_EXT register in the MWMR coprocessor
+//        To support addresses > 32 bits and remove this limitation...
+/////////////////////////////////////////////////////////////////////////////// 
+void mwmr_hw_init(paddr_t                coproc_pbase, 
+                  enum mwmrPortDirection way,
+                  unsigned int           no, 
+                  paddr_t                channel_pbase) 
+{
+    if ( (channel_pbase>>32) != 0 )
+    {
+        boot_puts("\n[BOOT ERROR] MWMR controller does not support address > 32 bits\n");
+        boot_exit();
+    }
+
+    unsigned int lsb = (unsigned int)channel_pbase;
+//  unsigned int msb = (unsigned int)(channel_pbase>>32);
+
+    unsigned int depth = boot_physical_read( channel_pbase + 16 );
+    unsigned int width = boot_physical_read( channel_pbase + 20 );
+
+    boot_physical_write( coproc_pbase + MWMR_CONFIG_FIFO_WAY*4, way );
+    boot_physical_write( coproc_pbase + MWMR_CONFIG_FIFO_NO*4, no );
+    boot_physical_write( coproc_pbase + MWMR_CONFIG_WIDTH*4, width);
+    boot_physical_write( coproc_pbase + MWMR_CONFIG_DEPTH*4, depth);
+    boot_physical_write( coproc_pbase + MWMR_CONFIG_STATUS_ADDR*4, lsb);
+    boot_physical_write( coproc_pbase + MWMR_CONFIG_BUFFER_ADDR*4, lsb + 24 );
+//  boot_physical_write( coproc_pbase + MWMR_CONFIG_PADDR_EXT*4, msb);
+    boot_physical_write( coproc_pbase + MWMR_CONFIG_RUNNING*4, 1 );
+}
 
 ////////////////////////////////////////////////////////////////////////////////
@@ -1281,5 +1238,6 @@
 // in the mapping_info file.
 ////////////////////////////////////////////////////////////////////////////////
-void boot_peripherals_init() {
+void boot_peripherals_init() 
+{
     mapping_header_t * header = (mapping_header_t *) & seg_mapping_base;
     mapping_cluster_t * cluster = boot_get_cluster_base(header);
@@ -1297,66 +1255,71 @@
     unsigned int channel_id;
 
-    for (cluster_id = 0; cluster_id < header->clusters; cluster_id++) {
+    for (cluster_id = 0; cluster_id < header->clusters; cluster_id++) 
+    {
 
 #if BOOT_DEBUG_PERI
-        boot_puts
-            ("\n[BOOT DEBUG] ****** peripheral initialisation in cluster ");
-        boot_putd(cluster_id);
-        boot_puts(" ******\n");
+boot_puts("\n[BOOT DEBUG] ****** peripherals initialisation in cluster ");
+boot_putd(cluster_id);
+boot_puts(" ******\n");
 #endif
 
         for (periph_id = cluster[cluster_id].periph_offset;
-                periph_id < cluster[cluster_id].periph_offset +
-                cluster[cluster_id].periphs; periph_id++) {
+             periph_id < cluster[cluster_id].periph_offset +
+             cluster[cluster_id].periphs; periph_id++) 
+        {
             unsigned int type = periph[periph_id].type;
             unsigned int channels = periph[periph_id].channels;
             unsigned int pseg_id = periph[periph_id].psegid;
 
-            unsigned int * pseg_base = (unsigned int *) pseg[pseg_id].base;
+            paddr_t pbase = pseg[pseg_id].base;
 
 #if BOOT_DEBUG_PERI
-            boot_puts("- peripheral type : ");
-            boot_putd(type);
-            boot_puts(" / address = ");
-            boot_putx((unsigned int) pseg_base);
-            boot_puts(" / channels = ");
-            boot_putd(channels);
-            boot_puts("\n");
-#endif
-
-            switch (type) {
+boot_puts("- peripheral type : ");
+boot_putd(type);
+boot_puts(" / pbase = ");
+boot_putl(pbase);
+boot_puts(" / channels = ");
+boot_putd(channels);
+boot_puts("\n");
+#endif
+
+            switch (type) 
+            {
                 case PERIPH_TYPE_IOC:    // vci_block_device component
-                    pseg_base[BLOCK_DEVICE_IRQ_ENABLE] = 1;
+                {
+                    paddr_t paddr = pbase + BLOCK_DEVICE_IRQ_ENABLE*4;
+                    boot_physical_write(paddr, 1);
 #if BOOT_DEBUG_PERI
-                    boot_puts("- IOC initialised\n");
-#endif
-                    break;
-
+boot_puts("- IOC initialised\n");
+#endif
+                }
+                break;
                 case PERIPH_TYPE_DMA:    // vci_multi_dma component
-                    for (channel_id = 0; channel_id < channels; channel_id++) {
-                        pseg_base[DMA_IRQ_DISABLE + channel_id * DMA_SPAN] = 0;
+                    for (channel_id = 0; channel_id < channels; channel_id++) 
+                    {
+                        paddr_t paddr = pbase + (channel_id*DMA_SPAN + DMA_IRQ_DISABLE) * 4;
+                        boot_physical_write(paddr, 0);
                     }
 #if BOOT_DEBUG_PERI
-                    boot_puts("- DMA initialised\n");
-#endif
-                    break;
-
+boot_puts("- DMA initialised\n");
+#endif
+                break;
                 case PERIPH_TYPE_NIC:    // vci_multi_nic component
-                    for (channel_id = 0; channel_id < channels; channel_id++) {
+                    for (channel_id = 0; channel_id < channels; channel_id++) 
+                    {
                         // TODO
                     }
 #if BOOT_DEBUG_PERI
-                    boot_puts("- NIC initialised\n");
-#endif
-                    break;
-
+boot_puts("- NIC initialised\n");
+#endif
+                break;
                 case PERIPH_TYPE_TTY:    // vci_multi_tty component
 #if BOOT_DEBUG_PERI
-                    boot_puts("- TTY initialised\n");
-#endif
-                    break;
-
+boot_puts("- TTY initialised\n");
+#endif
+                break;
                 case PERIPH_TYPE_IOB:    // vci_io_bridge component
-                    if (IOMMU_ACTIVE) {
+                    if (IOMMU_ACTIVE) 
+                    {
                         // TODO
                         // get the iommu page table physical address
@@ -1368,173 +1331,233 @@
                     }
 #if BOOT_DEBUG_PERI
-                    boot_puts("- IOB initialised\n");
-#endif
-                    break;
-            }            // end switch periph type
-        }            // end for periphs
+boot_puts("- IOB initialised\n");
+#endif
+                break;
+            }  // end switch periph type
+        }  // end for periphs
 
 #if BOOT_DEBUG_PERI
-        boot_puts
-            ("\n[BOOT DEBUG] ****** coprocessors initialisation in cluster ");
-        boot_putd(cluster_id);
-        boot_puts(" ******\n");
+boot_puts("\n[BOOT DEBUG] ****** coprocessors initialisation in cluster ");
+boot_putd(cluster_id);
+boot_puts(" ******\n");
 #endif
 
         for (coproc_id = cluster[cluster_id].coproc_offset;
-                coproc_id < cluster[cluster_id].coproc_offset +
-                cluster[cluster_id].coprocs; coproc_id++) {
-            unsigned no_fifo_to = 0;    //FIXME: should it be the map.xml who define the order?
+             coproc_id < cluster[cluster_id].coproc_offset +
+             cluster[cluster_id].coprocs; coproc_id++) 
+        {
+            unsigned no_fifo_to = 0;    //FIXME: should the map.xml define the order?
             unsigned no_fifo_from = 0;
-            unsigned int cpseg = pseg[coproc[coproc_id].psegid].base;
+
+            // Get physical base address for MWMR controler
+            paddr_t coproc_pbase = pseg[coproc[coproc_id].psegid].base;
 
 #if BOOT_DEBUG_PERI
-            boot_puts("- coprocessor name : ");
-            boot_puts(coproc[coproc_id].name);
-            boot_puts(" / nb ports = ");
-            boot_putd((unsigned int) coproc[coproc_id].ports);
-            boot_puts("\n");
+boot_puts("- coprocessor name : ");
+boot_puts(coproc[coproc_id].name);
+boot_puts(" / nb ports = ");
+boot_putd((unsigned int) coproc[coproc_id].ports);
+boot_puts("\n");
 #endif
 
             for (cp_port_id = coproc[coproc_id].port_offset;
-                    cp_port_id < coproc[coproc_id].port_offset + coproc[coproc_id].ports;
-                    cp_port_id++) {
-                //FIXME: the vspace_id should be the same for all ports: put it in the coproc?
+                 cp_port_id < coproc[coproc_id].port_offset + coproc[coproc_id].ports;
+                 cp_port_id++) 
+            {
                 unsigned int vspace_id = cp_port[cp_port_id].vspaceid;
-                unsigned int vobj_id = cp_port[cp_port_id].mwmr_vobjid + vspace[vspace_id].vobj_offset;
-
-                mwmr_channel_t * pmwmr = (mwmr_channel_t *) (vobj[vobj_id].paddr);
-
-                if (cp_port[cp_port_id].direction == PORT_TO_COPROC) {
+                unsigned int vobj_id = cp_port[cp_port_id].mwmr_vobjid + 
+                                          vspace[vspace_id].vobj_offset;
+
+                // Get MWMR channel base address 
+                paddr_t channel_pbase = vobj[vobj_id].paddr;
+
+                if (cp_port[cp_port_id].direction == PORT_TO_COPROC) 
+                {
 #if BOOT_DEBUG_PERI
-                    boot_puts("     port direction: PORT_TO_COPROC");
-#endif
-                    mwmr_hw_init((void *) cpseg, PORT_TO_COPROC, no_fifo_to, pmwmr);
+boot_puts("     port direction: PORT_TO_COPROC");
+#endif
+                    mwmr_hw_init(coproc_pbase, 
+                                 PORT_TO_COPROC, 
+                                 no_fifo_to, 
+                                 channel_pbase);
                     no_fifo_to++;
                 }
-                else {
+                else 
+                {
 #if BOOT_DEBUG_PERI
-                    boot_puts("     port direction: PORT_FROM_COPROC");
-#endif
-                    mwmr_hw_init((void *) cpseg, PORT_FROM_COPROC, no_fifo_from, pmwmr);
+boot_puts("     port direction: PORT_FROM_COPROC");
+#endif
+                    mwmr_hw_init(coproc_pbase, 
+                                 PORT_FROM_COPROC, 
+                                 no_fifo_from, 
+                                 channel_pbase);
                     no_fifo_from++;
                 }
 #if BOOT_DEBUG_PERI
-                boot_puts(", with mwmr: ");
-                boot_puts(vobj[vobj_id].name);
-                boot_puts(" of vspace: ");
-                boot_puts(vspace[vspace_id].name);
-#endif
-            }
+boot_puts(", with mwmr: ");
+boot_puts(vobj[vobj_id].name);
+boot_puts(" of vspace: ");
+boot_puts(vspace[vspace_id].name);
+#endif
+            } // end for cp_ports
         } // end for coprocs
     } // end for clusters
 } // end boot_peripherals_init()
 
+///////////////////////////////////////////////////////////////////////////////
+// This function returns in the vbase and length buffers the virtual base 
+// address and the length of the  segment allocated to the schedulers array 
+// in the cluster defined by the clusterid argument.
+///////////////////////////////////////////////////////////////////////////////
+void boot_get_sched_vaddr( unsigned int  cluster_id,
+                           unsigned int* vbase, 
+                           unsigned int* length )
+{
+    mapping_header_t* header = (mapping_header_t *) & seg_mapping_base;
+    mapping_vobj_t*   vobj   = boot_get_vobj_base(header);
+    mapping_vseg_t*   vseg   = boot_get_vseg_base(header);
+    mapping_pseg_t*   pseg   = boot_get_pseg_base(header);
+
+    unsigned int vseg_id;
+    unsigned int found = 0;
+
+    for ( vseg_id = 0 ; (vseg_id < header->vsegs) && (found == 0) ; vseg_id++ )
+    {
+        if ( (vobj[vseg[vseg_id].vobj_offset].type == VOBJ_TYPE_SCHED) && 
+             (pseg[vseg[vseg_id].psegid].cluster == cluster_id ) )
+        {
+            *vbase  = vseg[vseg_id].vbase;
+            *length = vobj[vseg[vseg_id].vobj_offset].length;
+            found = 1;
+        }
+    }
+    if ( found == 0 )
+    {
+        boot_puts("\n[BOOT ERROR] No vobj of type SCHED in cluster ");
+        boot_putd(cluster_id);
+        boot_puts("\n");
+        boot_exit();
+    }
+} // end boot_get_sched_vaddr()
 
 ///////////////////////////////////////////////////////////////////////////////
 // This function initialises all processors schedulers.
 // This is done by processor 0, and the MMU must be activated.
-// It initialises the boot_schedulers_paddr[gpid] pointers array.
+// It initialises the boot_chedulers[gpid] pointers array.
 // Finally, it scan all tasks in all vspaces to initialise the tasks contexts, 
 // as specified in the mapping_info data structure. 
 // For each task, a TTY channel, a TIMER channel, a FBDMA channel, and a NIC
-// channel can be allocated if required. 
+// channel are allocated if required. 
 ///////////////////////////////////////////////////////////////////////////////
-void boot_schedulers_init() {
-    mapping_header_t * header = (mapping_header_t *) & seg_mapping_base;
-    mapping_cluster_t * cluster = boot_get_cluster_base(header);
-    mapping_pseg_t * pseg = boot_get_pseg_base(header);
-    mapping_vspace_t * vspace = boot_get_vspace_base(header);
-    mapping_task_t * task = boot_get_task_base(header);
-    mapping_vobj_t * vobj = boot_get_vobj_base(header);
-    mapping_proc_t * proc = boot_get_proc_base(header);
-    mapping_irq_t * irq = boot_get_irq_base(header);
-
-    unsigned int alloc_tty_channel;    // TTY channel allocator
-    unsigned int alloc_nic_channel;    // NIC channel allocator
+void boot_schedulers_init() 
+{
+    mapping_header_t*  header  = (mapping_header_t *) & seg_mapping_base;
+    mapping_cluster_t* cluster = boot_get_cluster_base(header);
+    mapping_vspace_t*  vspace  = boot_get_vspace_base(header);
+    mapping_task_t*    task    = boot_get_task_base(header);
+    mapping_vobj_t*    vobj    = boot_get_vobj_base(header);
+    mapping_proc_t*    proc    = boot_get_proc_base(header);
+    mapping_irq_t*     irq     = boot_get_irq_base(header);
+
+    unsigned int cluster_id;    // cluster index in mapping_info 
+    unsigned int proc_id;       // processor index in mapping_info 
+    unsigned int irq_id;        // irq index in mapping_info
+    unsigned int vspace_id;     // vspace index in mapping_info
+    unsigned int task_id;       // task index in mapping_info
+
+    unsigned int alloc_tty_channel = 1;            // TTY channel allocator
+    unsigned int alloc_nic_channel = 0;            // NIC channel allocator
+    unsigned int alloc_cma_channel = 0;            // CMA channel allocator
+    unsigned int alloc_ioc_channel = 0;            // IOC channel allocator
     unsigned int alloc_dma_channel[NB_CLUSTERS];   // DMA channel allocators
-    unsigned int alloc_timer_channel[NB_CLUSTERS]; // user TIMER allocators
-
-    unsigned int cluster_id; // cluster global index 
-    unsigned int proc_id;    // processor global index 
-    unsigned int irq_id;     // irq global index 
-    unsigned int pseg_id;    // pseg global index 
-    unsigned int vspace_id;  // vspace global index 
-    unsigned int task_id;    // task global index;
-
-    // Step 0 : TTY, NIC, TIMERS and DMA channels allocators initialisation
-    //          global_id = cluster_id*NB_*_MAX + loc_id
-    //          - TTY[0] is reserved for the kernel
-    //          - In all clusters the first NB_PROCS_MAX timers 
-    //            are reserved for the kernel (context switch)
-
-    alloc_tty_channel = 1;
-    alloc_nic_channel = 0;
-
-    for (cluster_id = 0; cluster_id < header->clusters; cluster_id++) {
+    unsigned int alloc_tim_channel[NB_CLUSTERS];   // user TIMER allocators
+
+    /////////////////////////////////////////////////////////////////////////
+    // Step 1 : loop on the clusters and on the processors 
+    //          to initialize the schedulers[] array of pointers and
+    //          the interrupt vectors.
+    // Implementation note:
+    // We need to use both proc_id to scan the mapping info structure,
+    // and lpid to access the schedulers array.
+    // - the boot_schedulers[] array of pointers can contain "holes", because
+    //   it is indexed by the global pid = cluster_id*NB_PROCS_MAX + ltid
+    // - the mapping info array of processors is contiguous, it is indexed 
+    //   by proc_id, and use an offset specific in each cluster.
+
+    for (cluster_id = 0; cluster_id < header->clusters; cluster_id++) 
+    {
+
+#if BOOT_DEBUG_SCHED
+boot_puts("\n[BOOT DEBUG] Initialise schedulers in cluster ");
+boot_putd(cluster_id);
+boot_puts("\n");
+#endif
+
+        // TTY, NIC, CMA, IOC, TIM and DMA channels allocators 
+        // - TTY[0] is reserved for the kernel
+        // - In all clusters the first NB_PROCS_MAX timers 
+        //   are reserved for the kernel (context switch)
+
         alloc_dma_channel[cluster_id] = 0;
-        alloc_timer_channel[cluster_id] = 0;
-    }
-
-    // Step 1 : loop on the clusters and on the processors 
-    //          - initialise the boot_schedulers_paddr[] pointers array 
-    //          - initialise the interrupt vectors for each processor.
-
-    for (cluster_id = 0; cluster_id < header->clusters; cluster_id++) {
-
-#if BOOT_DEBUG_SCHED
-        boot_puts("\n[BOOT DEBUG] Initialise schedulers / IT vector in cluster ");
-        boot_putd(cluster_id);
-        boot_puts("\n");
-#endif
-        unsigned int found = 0;
-        unsigned int pseg_pbase;    // pseg base address 
-        unsigned int lpid;    // processor local index
-
-        // get the physical base address of the first PSEG_TYPE_RAM pseg in cluster
-        for (pseg_id = cluster[cluster_id].pseg_offset;
-                pseg_id < cluster[cluster_id].pseg_offset + cluster[cluster_id].psegs;
-                pseg_id++) {
-            if (pseg[pseg_id].type == PSEG_TYPE_RAM) {
-                pseg_pbase = pseg[pseg_id].base;
-                found = 1;
-                break;
-            }
-        }
-
-        if ((cluster[cluster_id].procs > 0) && (found == 0)) {
-            boot_puts("\n[BOOT ERROR] Missing RAM pseg in cluster ");
+        alloc_tim_channel[cluster_id] = NB_PROCS_MAX;
+
+        unsigned int  lpid;          // processor local index in cluster
+        unsigned int  sched_vbase;   // schedulers segment virtual base address
+        unsigned int  sched_length;  // schedulers segment length
+        unsigned int  nprocs;        // number of processors in cluster
+
+        nprocs = cluster[cluster_id].procs;
+
+        // checking processors number
+        if ( nprocs > NB_PROCS_MAX )
+        {
+            boot_puts("\n[BOOT ERROR] Too much processors in cluster ");
             boot_putd(cluster_id);
             boot_puts("\n");
             boot_exit();
         }
-        // 4 Kbytes per scheduler
-        for (lpid = 0; lpid < cluster[cluster_id].procs; lpid++) {
-            boot_schedulers_paddr[cluster_id * NB_PROCS_MAX + lpid] = (static_scheduler_t *) (pseg_pbase + (lpid << 12));
+ 
+        // get scheduler array virtual base address for cluster_id
+        boot_get_sched_vaddr( cluster_id, &sched_vbase, &sched_length );
+
+        // each processor scheduler requires 1 Kbytes
+        if ( sched_length < (nprocs<<10) ) 
+        {
+            boot_puts("\n[BOOT ERROR] Schedulers segment too small in cluster ");
+            boot_putd(cluster_id);
+            boot_puts("\n");
+            boot_exit();
         }
 
-        for (proc_id = cluster[cluster_id].proc_offset;
-                proc_id < cluster[cluster_id].proc_offset + cluster[cluster_id].procs;
-                proc_id++) {
+        for ( proc_id = cluster[cluster_id].proc_offset, lpid = 0 ;
+              proc_id < cluster[cluster_id].proc_offset + cluster[cluster_id].procs;
+              proc_id++, lpid++ ) 
+        {
+            // set the schedulers pointers array
+            boot_schedulers[cluster_id * NB_PROCS_MAX + lpid] =
+               (static_scheduler_t*)( sched_vbase + (lpid<<10) );
 
 #if BOOT_DEBUG_SCHED
-            boot_puts("\nProc ");
-            boot_putd(proc_id);
-            boot_puts(" : scheduler pbase = ");
-            boot_putx(pseg_pbase + (proc_id << 12));
-            boot_puts("\n");
-#endif
-            // initialise the "tasks" variable in scheduler
-            boot_scheduler_set_tasks(proc_id, 0);
+boot_puts("\nProc ");
+boot_putd(lpid);
+boot_puts(" : scheduler virtual base address = ");
+boot_putx( sched_vbase + (lpid<<10) );
+boot_puts("\n");
+#endif
+            // current processor scheduler pointer : psched
+            static_scheduler_t* psched = (static_scheduler_t*)(sched_vbase+(lpid<<10));
+
+            // initialise the "tasks" variable
+            psched->tasks = 0;
 
             // initialise the interrupt_vector with ISR_DEFAULT
             unsigned int slot;
-            for (slot = 0; slot < 32; slot++) {
-                boot_scheduler_set_itvector(proc_id, slot, 0);
-            }
+            for (slot = 0; slot < 32; slot++) psched->interrupt_vector[slot] = 0;
 
             // scan the IRQs actually allocated to current processor
             for (irq_id = proc[proc_id].irq_offset;
-                    irq_id < proc[proc_id].irq_offset + proc[proc_id].irqs;
-                    irq_id++) {
+                 irq_id < proc[proc_id].irq_offset + proc[proc_id].irqs;
+                 irq_id++) 
+            {
                 unsigned int type = irq[irq_id].type;
                 unsigned int icu_id = irq[irq_id].icuid;
@@ -1542,16 +1565,18 @@
                 unsigned int channel = irq[irq_id].channel;
                 unsigned int value = isr_id | (type << 8) | (channel << 16);
-                boot_scheduler_set_itvector(proc_id, icu_id, value);
+                psched->interrupt_vector[icu_id] = value;
 
 #if BOOT_DEBUG_SCHED
-                boot_puts("- IRQ : icu = ");
-                boot_putd(icu_id);
-                boot_puts(" / type = ");
-                boot_putd(type);
-                boot_puts(" / isr = ");
-                boot_putd(isr_id);
-                boot_puts(" / channel = ");
-                boot_putd(channel);
-                boot_puts("\n");
+boot_puts("- IRQ : icu = ");
+boot_putd(icu_id);
+boot_puts(" / type = ");
+boot_putd(type);
+boot_puts(" / isr = ");
+boot_putd(isr_id);
+boot_puts(" / channel = ");
+boot_putd(channel);
+boot_puts(" => vector_entry = ");
+boot_putx( value );
+boot_puts("\n");
 #endif
             }
@@ -1559,23 +1584,34 @@
     } // end for clusters
 
+    ///////////////////////////////////////////////////////////////////
     // Step 2 : loop on the vspaces and the tasks 
     //          to initialise the schedulers and the task contexts.
-
-    for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) {
+    // Implementation note:
+    // This function initialises the task context for all tasks.
+    // For each processor, the scheduler virtual base address 
+    // is written in the CP0_SCHED register in reset.S 
+
+    for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) 
+    {
 
 #if BOOT_DEBUG_SCHED
-        boot_puts
-            ("\n[BOOT DEBUG] Initialise schedulers / task contexts for vspace ");
-        boot_puts(vspace[vspace_id].name);
-        boot_puts("\n");
+boot_puts("\n[BOOT DEBUG] Initialise task contexts for vspace ");
+boot_puts(vspace[vspace_id].name);
+boot_puts("\n");
 #endif
         // We must set the PTPR depending on the vspace, because the start_vector 
         // and the stack address are defined in virtual space.
-        boot_set_mmu_ptpr((unsigned int) boot_ptabs_paddr[vspace_id] >> 13);
+        boot_set_mmu_ptpr( (unsigned int)(boot_ptabs_paddr[vspace_id] >> 13) );
 
         // loop on the tasks in vspace (task_id is the global index)
         for (task_id = vspace[vspace_id].task_offset;
-                task_id < (vspace[vspace_id].task_offset + vspace[vspace_id].tasks);
-                task_id++) {
+             task_id < (vspace[vspace_id].task_offset + vspace[vspace_id].tasks);
+             task_id++) 
+        {
+            // compute gpid (global processor index) and scheduler base address
+            unsigned int gpid = task[task_id].clusterid * NB_PROCS_MAX + 
+                                task[task_id].proclocid;
+            static_scheduler_t* psched = boot_schedulers[gpid];
+
             // ctx_ra :  the return address is &boot_eret()
             unsigned int ctx_ra = (unsigned int) &boot_eret;
@@ -1585,16 +1621,15 @@
 
             // ctx_ptpr : page table physical base address (shifted by 13 bit)
-            unsigned int ctx_ptpr = (unsigned int) boot_ptabs_paddr[vspace_id] >> 13;
-
-            // compute gpid = global processor index
-            unsigned int gpid = task[task_id].clusterid * NB_PROCS_MAX + task[task_id].proclocid;
+            unsigned int ctx_ptpr = (unsigned int)(boot_ptabs_paddr[vspace_id] >> 13);
 
             // ctx_ptab : page_table virtual base address
-            unsigned int ctx_ptab = (unsigned int) boot_ptabs_vaddr[vspace_id];
-
-            // ctx_tty : terminal global index provided by a global allocator
+            unsigned int ctx_ptab = boot_ptabs_vaddr[vspace_id];
+
+            // ctx_tty : terminal global index provided by the global allocator
             unsigned int ctx_tty = 0xFFFFFFFF;
-            if (task[task_id].use_tty) {
-                if (alloc_tty_channel >= NB_TTYS) {
+            if (task[task_id].use_tty) 
+            {
+                if (alloc_tty_channel >= NB_TTY_CHANNELS) 
+                {
                     boot_puts("\n[BOOT ERROR] TTY index too large for task ");
                     boot_puts(task[task_id].name);
@@ -1607,8 +1642,10 @@
                 alloc_tty_channel++;
             }
-            // ctx_nic : NIC channel global index provided by a global allocator
+            // ctx_nic : NIC channel global index provided by the global allocator
             unsigned int ctx_nic = 0xFFFFFFFF;
-            if (task[task_id].use_nic) {
-                if (alloc_nic_channel >= NB_NICS) {
+            if (task[task_id].use_nic) 
+            {
+                if (alloc_nic_channel >= NB_NIC_CHANNELS) 
+                {
                     boot_puts("\n[BOOT ERROR] NIC channel index too large for task ");
                     boot_puts(task[task_id].name);
@@ -1621,11 +1658,44 @@
                 alloc_nic_channel++;
             }
-            // ctx_timer : user TIMER global index provided by a cluster allocator 
-            unsigned int ctx_timer = 0xFFFFFFFF;
-            if (task[task_id].use_timer) {
+            // ctx_cma : CMA channel global index provided by the global allocator
+            unsigned int ctx_cma = 0xFFFFFFFF;
+            if (task[task_id].use_cma) 
+            {
+                if (alloc_cma_channel >= NB_CMA_CHANNELS) 
+                {
+                    boot_puts("\n[BOOT ERROR] CMA channel index too large for task ");
+                    boot_puts(task[task_id].name);
+                    boot_puts(" in vspace ");
+                    boot_puts(vspace[vspace_id].name);
+                    boot_puts("\n");
+                    boot_exit();
+                }
+                ctx_cma = alloc_cma_channel;
+                alloc_cma_channel++;
+            }
+            // ctx_ioc : IOC channel global index provided by the global allocator
+            unsigned int ctx_ioc = 0xFFFFFFFF;
+            if (task[task_id].use_ioc) 
+            {
+                if (alloc_ioc_channel >= NB_IOC_CHANNELS) 
+                {
+                    boot_puts("\n[BOOT ERROR] IOC channel index too large for task ");
+                    boot_puts(task[task_id].name);
+                    boot_puts(" in vspace ");
+                    boot_puts(vspace[vspace_id].name);
+                    boot_puts("\n");
+                    boot_exit();
+                }
+                ctx_ioc = alloc_ioc_channel;
+                alloc_ioc_channel++;
+            }
+            // ctx_tim : TIMER local channel index provided by the cluster allocator 
+            unsigned int ctx_tim = 0xFFFFFFFF;
+            if (task[task_id].use_tim) 
+            {
                 unsigned int cluster_id = task[task_id].clusterid;
-                unsigned int allocated = alloc_timer_channel[cluster_id];
-
-                if (allocated >= NB_TIMERS_MAX) {
+
+                if ( alloc_tim_channel[cluster_id] >= NB_TIM_CHANNELS ) 
+                {
                     boot_puts("\n[BOOT ERROR] local TIMER index too large for task ");
                     boot_puts(task[task_id].name);
@@ -1635,23 +1705,23 @@
                     boot_exit();
                 }
-                //assert(allocated >= 0);
-                char found = 0;
-                for (irq_id = 0; irq_id < 32; irq_id++) { //look at the isr_timer isr channel
-                    unsigned int isr = boot_scheduler_get_itvector(gpid, irq_id) & 0x000000FF;
-                    if (isr == ISR_TIMER) {
-                        if (allocated == 0) {
-                            found = 1;
-                            alloc_timer_channel[cluster_id]++;
-                            ctx_timer = cluster_id * NB_TIMERS_MAX + alloc_timer_channel[cluster_id];
-                            break;
-                        }
-                        else {
-                            allocated--;
-                        }
+
+                // checking that there is a well defined ISR_TIMER installed
+                unsigned int found = 0;
+                for ( irq_id = 0 ; irq_id < 32 ; irq_id++ )  
+                {
+                    unsigned int entry   = psched->interrupt_vector[irq_id];
+                    unsigned int isr     = entry & 0x000000FF;
+                    unsigned int channel = entry>>16;
+                    if ( (isr == ISR_TIMER) && (channel == alloc_tim_channel[cluster_id]) ) 
+                    {
+                        found     = 1;
+                        ctx_tim =  alloc_tim_channel[cluster_id];
+                        alloc_tim_channel[cluster_id]++;
+                        break;
                     }
                 }
-
-                if (!found) {
-                    boot_puts("\n[BOOT ERROR] No user timer available for task ");
+                if (!found) 
+                {
+                    boot_puts("\n[BOOT ERROR] No ISR_TIMER installed for task ");
                     boot_puts(task[task_id].name);
                     boot_puts(" in vspace ");
